unit DifferencesTreeUnit;

{$mode delphi}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ComCtrls,
  EditBtn, StdCtrls, Buttons, ucosa, types, lclintf, ExtCtrls, ColorBox, Messages,
  xmatdefs;

type

  //TListBox = class(TListBox)
  //private
  //  FOnScroll: TNotifyEvent;
  //protected
  //  procedure ListBoxScroll(var Message: TMessage); message WM_VSCROLL;
  //public
  //  property OnScroll: TNotifyEvent read FOnScroll write FOnScroll;
  //end;

  { TDifferencesTreeForm }

  TDifferencesTreeForm = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn3: TBitBtn;
    Button1: TButton;
    eb_DataSet1: TEditButton;
    eb_DataSet2: TEditButton;
    DifferencesLabel: TLabel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    OpenDialog: TOpenDialog;
    Panel1: TPanel;
    Panel2: TPanel;
    ScrollBar1: TScrollBar;
    procedure Button1Click(Sender: TObject);
    procedure ListBoxMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure ScrollBar1Scroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure SiguienteButtonClick(Sender: TObject);
    procedure AnteriorButtonClick(Sender: TObject);
    procedure eb_DataSetButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBoxDrawItem(Control: TWinControl; Index: Integer;
      ARect: TRect; State: TOwnerDrawState);
  private
    //procedure DoScrollListBox(Sender: TObject);
    //procedure ListBox1Click(Sender: TObject);
    { private declarations }
  public
    ChangedItemIndex:string;
    ChangedItemIndexList:string;
    line:integer;
    procedure Print(DataSet: TDataStore; DataTableName: string; DataRowId: integer;
      var ListBox: TListBox; indentation: string='');
  end;

var
  DifferencesTreeForm: TDifferencesTreeForm;

implementation

uses
  uFormEditSimSEE;

{$R *.lfm}

//procedure TListBox.ListBoxScroll(var Message: TMessage);
//begin
//  inherited;
//  if Assigned(FOnScroll) then
//    FOnScroll(Self);
//end;

{ TDifferencesTreeForm }

//procedure TDifferencesTreeForm.DoScrollListBox(Sender: TObject);
//begin
//  self.ListBox3.TopIndex := self.ListBox1.TopIndex;
//end;

//procedure TDifferencesTreeForm.ListBox1Click(Sender: TObject);
//begin
//  self.ListBox3.TopIndex := self.ListBox1.TopIndex;
//end;

procedure TDifferencesTreeForm.FormCreate(Sender: TObject);
begin
  self.line:=0;
  ListBox1.OnMouseWheel:=ListBoxMouseWheel();
  ListBox2.OnMouseWheel:=ListBoxMouseWheel();
  ListBox3.OnMouseWheel:=ListBoxMouseWheel();

  ListBox1.OnDrawItem:=ListBoxDrawItem;
  ListBox2.OnDrawItem:=ListBoxDrawItem;

  ListBox1.Style := lbOwnerDrawFixed;
  ListBox2.Style := lbOwnerDrawFixed;

  //self.ListBox1.OnScroll := DoScrollListBox1;
end;

procedure TDifferencesTreeForm.ListBoxDrawItem(Control: TWinControl;
  Index: Integer; ARect: TRect; State: TOwnerDrawState);
var
  DataCell: TDataCellOfCosa;
  FontColor:TColor;
  MyBrush:TBrush;
begin

  with (Control as TListBox).Canvas do
  begin

    Font.Color := clBlack;
    Brush.Color := clWhite;

    if (Control as TListBox).Items.Objects[index] is TDataCellOfCosa then
    begin
      DataCell:=TDataCellOfCosa((Control as TListBox).Items.Objects[index]);
      if DataCell.Changed then
      begin
        Font.Color := clWhite;
        Brush.Color := clRed;
      end;
    end;

    FillRect(ARect);
    Brush.Style := bsClear;
    TextOut(ARect.Left, ARect.Top, (Control as TListBox).Items[Index]);
  end;

end;

procedure TDifferencesTreeForm.eb_DataSetButtonClick(Sender: TObject);
begin
  self.OpenDialog:=TOpenDialog.Create(self);
  self.OpenDialog.Filter := 'Sala SimSEE|*.ese';
  if self.OpenDialog.Execute then
  begin
    if (TEditButton(sender).Name='eb_DataSet1') then
      self.eb_DataSet1.Text:=self.OpenDialog.Filename
    else
      self.eb_DataSet2.Text:=self.OpenDialog.Filename;
    self.openDialog.Free;
  end;
end;

procedure TDifferencesTreeForm.Button1Click(Sender: TObject);
var
  ch: TSalaDeJuegoConnection;
  Alfa_DataSet, Beta_DataSet, AlfaGama_DataSet, BetaGama_DataSet:TDataStore;
  filename1, filename2:string;
  DAO: TDAOfDataStore;
  z: Integer;
  j: Integer;
  DataTable: TDataTableOfCosa;
  DataRow: TDataRowOfCosa;
  a: Integer;
  dt: TDataTableOfCosa;
  i: Integer;
  split: TStringList;
  l: Integer;
begin
  filename1:=self.eb_DataSet1.Text;
  filename2:=self.eb_DataSet2.Text;

  ch:=TSalaDeJuegoConnection.Create(filename1);
  ch.ReadDataStoreFromTextFile();
  Alfa_DataSet:=DATA_STORE.Clone();

  for z:=0 to DATA_STORE.DataTableListCount-1 do
    DATA_STORE.DataTableList[z].Clear();

  ch:=TSalaDeJuegoConnection.Create(filename2);
  ch.ReadDataStoreFromTextFile();
  Beta_DataSet:=DATA_STORE.Clone();

  AlfaGama_DataSet:=nil;
  Alfa_DataSet.CompareTo(Beta_DataSet, 'dt_TSalaDeJuego', 1001, AlfaGama_DataSet);
  ucosa.PrintDataSet(Beta_DataSet);
  self.Print(AlfaGama_DataSet, 'dt_TSalaDeJuego', 1001, self.ListBox1);

  BetaGama_DataSet:=nil;
  Beta_DataSet.CompareTo(Alfa_DataSet, 'dt_TSalaDeJuego', 1001, BetaGama_DataSet);
  self.Print(BetaGama_DataSet, 'dt_TSalaDeJuego', 1001, self.ListBox2);

  self.ScrollBar1.Max:=self.ListBox1.Items.Count;

  for l:=1 to self.ListBox1.Count do
    ListBox3.Items.Add(IntToStr(l));

  split:=TStringList.Create();
  ExtractStrings([','], [], PChar(self.ChangedItemIndexList), split);
  self.DifferencesLabel.Caption:='Se encontraron ' + IntToStr(split.Count) + ' diferencias.';

end;

procedure TDifferencesTreeForm.ListBoxMouseWheel(Sender: TObject;
  Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
begin

  if TListBox(Sender).Name = self.ListBox1.Name then
  begin
    self.ListBox2.TopIndex:=self.ListBox1.TopIndex;
    self.ListBox3.TopIndex:=self.ListBox1.TopIndex;
  end;

  if TListBox(Sender).Name = self.ListBox2.Name then
  begin
    self.ListBox1.TopIndex:=self.ListBox2.TopIndex;
    self.ListBox3.TopIndex:=self.ListBox2.TopIndex;
  end;

  if TListBox(Sender).Name = self.ListBox3.Name then
  begin
    self.ListBox1.TopIndex:=self.ListBox3.TopIndex;
    self.ListBox2.TopIndex:=self.ListBox3.TopIndex;
  end;

  self.ScrollBar1.Position:=TListBox(Sender).TopIndex;

end;

procedure TDifferencesTreeForm.ScrollBar1Scroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  self.ListBox1.TopIndex:=ScrollPos;
  self.ListBox2.TopIndex:=ScrollPos;
  self.ListBox3.TopIndex:=ScrollPos;

end;

procedure TDifferencesTreeForm.SiguienteButtonClick(Sender: TObject);
var
  index: Integer;
  i: Integer;
  split: TStringList;
begin

  split:=TStringList.Create();
  ExtractStrings([','], [], PChar(self.ChangedItemIndexList), split);
  if (ChangedItemIndex='') or (ChangedItemIndex=split[split.Count-1]) then
    ChangedItemIndex:=split[0]
  else
    for i:=0 to split.Count do
      if split[i]=ChangedItemIndex then
      begin
        ChangedItemIndex:=split[i+1];
        self.ListBox1.Selected[StrToInt(ChangedItemIndex)]:=true;
        self.Listbox1.ItemIndex:=StrToInt(ChangedItemIndex);
        self.ListBox1.TopIndex:=StrToInt(ChangedItemIndex);

        self.ListBox2.Selected[StrToInt(ChangedItemIndex)]:=true;
        self.Listbox2.ItemIndex:=StrToInt(ChangedItemIndex);
        self.ListBox2.TopIndex:=StrToInt(ChangedItemIndex);

        self.ListBox3.Selected[StrToInt(ChangedItemIndex)]:=true;
        self.Listbox3.ItemIndex:=StrToInt(ChangedItemIndex);
        self.ListBox3.TopIndex:=StrToInt(ChangedItemIndex);
        break;
      end;
  split.Free;
end;

procedure TDifferencesTreeForm.AnteriorButtonClick(Sender: TObject);
var
  index: Integer;
begin

end;

{ TDifferencesTreeForm }

procedure TDifferencesTreeForm.Print(DataSet: TDataStore;
  DataTableName: string; DataRowId: integer; var ListBox: TListBox;
  indentation: string);
var
  DataTable: TDataTableOfCosa;
  DataRow: TDataRowOfCosa;
  DataColumn: TDataColumnOfCosa;
  DataCell: TDataCellOfCosa;
  split: TStrings;
  j: Integer;
  sval: string;
  DataTableChildName: String;
  DataRowChildId: Integer;
  DataCellChildSVal: String;
  daos: TDAofString;
  z: Integer;
  a: Integer;
  index: Integer;
begin
  DataTable:=DataSet.GetDataTableByName(DataTableName);

  DataRow:=DataTable.GetDataRowById(DataRowId);

  if (DataRow.RowName[4]=':')then
    ListBox.Items.AddObject(indentation+':'+' = '+'<+'+Copy(DataTable.TableName,4,Length(DataTable.TableName)-3)+'>', nil)
  else
    ListBox.Items.AddObject(indentation+Copy(DataRow.RowName,4,Length(DataRow.RowName)-3)+' = '+'<+'+Copy(DataTable.TableName,4,Length(DataTable.TableName)-3)+'>',nil);

  for j:=0 to DataTable.DataColumnListCount-1 do
  begin
    if (j<DataRow.DataCellListCount) then
    begin
      DataColumn:=DataTable.DataColumnList[j];
      DataCell:=DataRow.DataCellList[j];
      sval:=DataCell.sval;
      if (DataColumn.DataType is TDataTypeDataRowOfCosa) then
      begin
        if (sval<>'') then
        begin
          split := TStringList.Create;
          ExtractStrings(['.'], [], PChar(sval), split);
          DataTableChildName:=split[0];
          DataRowChildId:=StrToInt(split[1]);
          self.Print(DataSet, DataTableChildName, DataRowChildId, ListBox, indentation+'    ');
          split.Free;
        end
      end
      else if (DataColumn.DataType is TDataTypeListOfCosa) then
      begin
        if (sval<>'') then
        begin
          split := TStringList.Create;
          ExtractStrings(['.'], [], PChar(sval), split);
          DataTableChildName:=split[0];
          DataCellChildSVal:=split[2];
          split.Free;
          daos:=DATA_STORE.ReadDataCellTextValues(DataTableChildName,'idParent',DataCellChildSVal,'idchild');
          for z:=0 to length(daos)-1 do
          begin
            split:=TStringList.Create;
            ExtractStrings(['.'], [], PChar(daos[z]), split);
            DataTableChildName:=split[0];
            DataRowChildId:=StrToInt(split[1]);
            split.Free;
            if (DataRowChildId=1060) then
              a:=1;
            self.Print(DataSet, DataTableChildName, DataRowChildId, ListBox, indentation+'    ');
          end;
        end;
      end
      else
        begin
          index:=ListBox.Items.AddObject(indentation+'    '+DataColumn.ColumnName+' = '+sval, DataCell);

          if DataCell.Changed then
            self.ChangedItemIndexList:=self.ChangedItemIndexList+IntToStr(index)+',';
        end;
    end;
  end;
  ListBox.AddItem(indentation+'<-'+Copy(DataTable.TableName,4,Length(DataTable.TableName)-3)+'>',nil);

end;

end.

