unit uGrillasParaEditor;

{$mode delphi}

interface

uses
  Classes, SysUtils, Forms, Controls, Dialogs, Graphics, ucosa, uFormularioBase,
  uStringGridWithControls,
  uRegistroDeEditores;

type

  { TGrillaParaEditor }

  // Este tipo de grilla solo lleva BitBtns en la ultima columna
  TGrillaParaEditor=class(TStringGridWithControls)
  public

    DataSet: TDataStore;
    DataRowList: TList;

    constructor Create (AOwner: TComponent; AParent:TWinControl; AName: string;
      ds: TDataStore);

    function GetDataRow(kRow: Integer):TDataVRowOfCosa;

    procedure Refresh(vdt: TDataVTableOfCosa);

    //procedure Lupa_OnClick(nidRec: string; kFila: integer); override;
    //procedure Clonar_OnClick(nidRec: string; kFila: integer); override;
    //procedure Borrar_OnClick(nidRec: string; kFila: integer); override;

    procedure ClearAll; override;

  end;


implementation

uses
  uFormularioAutomatico;


{ TGrillaParaEditor }

constructor TGrillaParaEditor.Create(AOwner: TComponent; AParent: TWinControl;
  AName: string; ds: TDataStore);
var
  i: Integer;
  dcl: TDataColumnListOfCosa;
  dc: TDataColumnOfCosa;
begin

  inherited Create(AOwner, AParent, AName);
  self.DataSet:=ds;
  self.DataRowList:=TList.Create;

end;


{ TGrillaParaEditor }

function TGrillaParaEditor.GetDataRow(kRow: Integer): TDataVRowOfCosa;
begin
  if (kRow<=DataRowList.Count) then
    Result := DataRowList.Items[kRow-1]
  else
    Result:=nil;
end;

procedure TGrillaParaEditor.Refresh(vdt: TDataVTableOfCosa);
var
  dt: TDataTableOfCosa;
  i,j: Integer;
  DataRow: TDataRowOfCosa;
  Values: TStrings;
begin
  self.ClearAll;
  dt:=DataSet.View(vdt);

  for i:=0 to dt.DataRowListCount-1 do
  begin
    DataRow:= dt.DataRowList[i];
    Values:=DataRow.ToString();
    InsertRow(Values);

    self.DataRowList.Add(DataRow);
  end;

  self.AutoSizeColumns;
end;

//procedure TGrillaParaEditor.Clonar_OnClick(nidRec: string; kFila: integer);
//var
//  ADataSet:TDataStore;
//
//  frmCurrent, frmChild: TFormularioBase;
////  ctrlParent:TEditorDataGridControl;
//
//  CosaStrId: String;
//  Value: String;
//  DataRow: TDataVRowOfCosa;
//  From: String;
//  ColName: String;
//  RowId: Integer;
//  DataColumn: TDataColumnOfCosa;
//  DataCell: TDataCellOfCosa;
//
//begin
//
//  frmCurrent := TFormularioBase(self.Owner);
//
//  DataColumn:= frmCurrent.LocalDataColumnList.Items[Parent.Tag];
//  DataCell:= frmCurrent.LocalDataRow.DataCellList[Parent.Tag];
//
//  //Obtengo la fila virtual de la tabla y el DataSet de la ventana
//  DataRow:=GetDataRow(kFila);
//  ADataSet:= TDataStore.Create(DataSet);
//
//  //El valor a editar
//  Value:= DataRow.OriginalDataTableName+'.'+IntToStr(DataRow.OriginalDataRowId);
//
//  From:=frmCurrent.LocalDataRow.DataCellList[Parent.Tag].DataRowOwner.DataTableOwner.TableName;
//  //ColName:=frmCurrent.LocalDataColumnList.Items[Parent.Tag].ColumnName;
//  RowId:=frmCurrent.LocalDataRow.DataCellList[Parent.Tag].DataRowOwner._RowId;
//
//  ADataSet:=DataSet.PrepareInsert(From, 'lst', RowId, Value, true //TRUE: en la lupa siempre es un elemento de una lista
//  {IsChild(TListaDeCosas, ctrlParent.DataColumn.DataType.ClaseDeCosa)});
//
//  CosaStrId:=copy(DataRow.OriginalDataTableName,4,Length(DataRow.OriginalDataTableName));
//
//  frmChild:= OpenForm (frmCurrent ,
//                       CosaStrId,
//                       ADataSet,
//                       frmCurrent.Caption+' >> '+'lst['+name+']');
//
//  if frmChild.ShowModal() = mrOk then
//    frmCurrent.DataSet.Merge(frmChild.DataSet);
//
//end;
//
//procedure TGrillaParaEditor.Borrar_OnClick(nidRec: string; kFila: integer);
//var
//  ADataSet:TDataStore;
//  frmCurrent: TFormularioBase;
//  Value: String;
//  DataTableParentName: String;
//  DataRow: TDataVRowOfCosa;
//  From: String;
//  RowId: Integer;
//begin
//   frmCurrent := TFormularioBase(self.Owner);
//
//   DataRow:=GetDataRow(kFila);
//
//   Value:= DataRow.OriginalDataTableName+'.'+IntToStr(DataRow.OriginalDataRowId);
//
//   From:=frmCurrent.LocalDataRow.DataCellList[Parent.Tag].DataRowOwner.DataTableOwner.TableName;
//   RowId:=frmCurrent.LocalDataRow.DataCellList[Parent.Tag].DataRowOwner._RowId;
//
//   ADataSet:=DataSet.PrepareDelete(From, 'lst', RowId, Value, true);
//end;

procedure TGrillaParaEditor.ClearAll;
var
  i: Integer;
begin

  writeln('DataRowList.Count ',DataRowList.Count);
  for i:=1 to DataRowList.Count-1 do
    if Assigned(GetDataRow(i)) then
      GetDataRow(i).Free();

  DataRowList.Clear;

  inherited ClearAll;

end;

end.

